/**************************************************************************
* iptrk - ip tracker
* Copyright (C) 2003 Jason Nunn <jsno@leal.com.au>
* Darwin, NT, Australia. 
* Originally developed for Arafura Connect (Dec 2000 - Mar 2003)
* Donated to GPL before liquidation.
*
* =======================================================================
* cgi routines
*
**************************************************************************/
#include "defs.h"
#include "lib.p"

#define BLOCK_SIZE 100

PUBLIC FILE        *web_fp;
PUBLIC dir_entry_t *dir_tab;
PUBLIC int         dir_len;
PUBLIC int         dir_buf_size;

/**************************************************************************
*
**************************************************************************/
PRIVATE int dir_tab_compar(const void *a, const void *b)
{
  return ((dir_entry_t *)b)->time_stamp - ((dir_entry_t *)a)->time_stamp;
}

/**************************************************************************
*
**************************************************************************/
PUBLIC void get_dir_entries_unsorted(char *path)
{
  char          str[STR_LEN + 1];
  DIR           *dp;
  struct dirent *d_st;
  struct stat   buf;

  dp = opendir(path);
  if(dp == NULL)
    exit(-1);

  for(;;)
  {
    d_st = readdir(dp);
    if(d_st == NULL)
      break;

    if(d_st->d_name[0] == '.')
      continue;

    strcpy(str, path);
    strcat(str, "/");
    strcat(str, d_st->d_name);
    if(stat(str, &buf))
      continue;

    if(dir_buf_size >= dir_len)
    {
      dir_buf_size += BLOCK_SIZE;
      dir_tab = realloc_mem(dir_tab, dir_buf_size * sizeof(dir_entry_t));
    }

    dir_tab[dir_len].time_stamp = buf.st_mtime;
    strncpy2(dir_tab[dir_len].name, d_st->d_name, STR_LEN);
    dir_len++;
  }

  closedir(dp);
}

/**************************************************************************
*
**************************************************************************/
PUBLIC inline void get_dir_entries(char *path)
{
  get_dir_entries_unsorted(path);
  qsort(dir_tab, dir_len, sizeof(dir_entry_t), dir_tab_compar);
}

/**************************************************************************
*
**************************************************************************/
PUBLIC void cgi_log_m(char type, const char *func, char *msg)
{
  if(func == NULL)
    fprintf(web_fp, "<font color=#ffffff>%c %s</font>", type, msg);
  else
    fprintf(web_fp, "<font color=#ffffff>%c %s()%s</font>", type, func, msg);

  if(type == 'E')
  {
    fprintf(web_fp, "<hr></center></body></html>\n");
    fclose(web_fp);
  }
}
